//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <vfw.h>
#include <math.h>
#include <fstream.h>
USELIB("user32.lib");
#include "winuser.h";
#include "Unit1.h"
#include <time.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
/* user variable */
HWND hCapWnd1,hCapWnd2;
Graphics::TBitmap *background = new Graphics::TBitmap();
Graphics::TBitmap *background2 = new Graphics::TBitmap();
Graphics::TBitmap *timeframe = new Graphics::TBitmap();
Graphics::TBitmap *timeframe2 = new Graphics::TBitmap();

unsigned char **RMatrix,**GMatrix,**BMatrix;   //RGB
int x,y,z,video_width=320,video_height=240 ;
clock_t StartTime;//ŧi@ӫAclock_tܼStartTime
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Timer1->Enabled=false;
        Button2->Enabled=false;
        Button3->Enabled=false;

        TrackBar1->Max=255;
        TrackBar1->Min=0;
        TrackBar1->Position=0;
        TrackBar2->Max=255;
        TrackBar2->Min=0;
        TrackBar2->Position=0;
        Label1->Caption=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)     //webcam1}ҼvJpanel1
{
        Timer1->Enabled=false;
        capDriverDisconnect(hCapWnd1);
        hCapWnd1=capCreateCaptureWindow("My Capture Window", WS_VISIBLE | WS_CHILD ,0, 0,
        video_width, video_height,Panel1->Handle, 0);
        capDriverConnect (hCapWnd1, 0);
        capPreviewRate(hCapWnd1,30);
        capPreview(hCapWnd1,1);
        capDlgVideoSource (hCapWnd1);
        Panel1->DoubleBuffered = true;
        Timer1->Enabled=false;
        Button2->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)      //^webcamvI
{        //^webcam1
        Timer1->Enabled=false;
        capGrabFrameNoStop(hCapWnd1);
        capFileSaveDIB(hCapWnd1,"place1.bmp");
        background->LoadFromFile("place1.bmp");
        background->PixelFormat = pf24bit;
        Image1->AutoSize=false;
        Image1->Stretch=true;
           //webcam1Ƕ¥ճB
        int sum,i,j;
        Byte *ptr1;
        for(int y=0;y<video_height;y++)
        {
                ptr1=(Byte *)background->ScanLine[y];
                for(int x=0;x<video_width*3;x+=3)
                {
                        sum=0;
                        for(int z=0;z<=2;z++)
                                sum+=ptr1[x+z];
                        for(int z=0;z<=2;z++)
                                ptr1[x+z]=sum/3;
                }
        }

        //Iwebcam2
        capGrabFrameNoStop(hCapWnd2);
        capFileSaveDIB(hCapWnd2,"place2.bmp");
        background2->LoadFromFile("place2.bmp");
        //background->PixelFormat = pf24bit;
        Image2->AutoSize=false;
        Image2->Stretch=true;
              //webcam2Qmv^,DNbo!!

     //RGB}C
         try
    {
        RMatrix = new unsigned char *[video_height];
        for (j=0;j<video_height;j++)
            RMatrix[j] = new unsigned char [video_width];

        GMatrix = new unsigned char *[video_height];
        for (j=0;j<video_height;j++)
            GMatrix[j] = new unsigned char [video_width];

        BMatrix = new unsigned char *[video_height];
        for (j=0;j<video_height;j++)
            BMatrix[j] = new unsigned char [video_width];
    }

    //pGO餣ɸXĵi
    catch (std::bad_alloc)
    {
        ShowMessage("Could not allocate memory...Bye");
        exit(-1);
    }
    //NϤRGBȩJ}C
    //ӦpvmIϩO

    for (i=0;i<video_height;i++)
    {
             //ptr1=(Byte *)background2->ScanLine[y];
             for (j=0;j<video_width;j++)
             {
                   RMatrix[i][j] = GetRValue(Panel2->Canvas->Pixels[j][i]);
                   GMatrix[i][j] = GetGValue(Panel2->Canvas->Pixels[j][i]);
                   BMatrix[i][j] = GetBValue(Panel2->Canvas->Pixels[j][i]);
             }
    }
    for(int y=0;y<video_height;y++)
        {
                ptr1=(Byte *)background2->ScanLine[y];
                for(int x=0;x<video_width;x++)
                {
                    Image2->Canvas->Pixels[x][y] = (TColor)RGB(RMatrix[y][x],GMatrix[y][x],BMatrix[y][x]);

                }
        }



        Image1->Picture->Bitmap=background;
        //Image2->Picture->Bitmap=background2;
        Button3->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
/*        */
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
        Close();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
        Timer1->Enabled=true;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)  //v
{
        capGrabFrameNoStop(hCapWnd1);
        capFileSaveDIB(hCapWnd1,"place1.bmp");
        timeframe->LoadFromFile("place1.bmp");
        timeframe->PixelFormat = pf24bit;
        Image1->AutoSize=false;
        Image1->Stretch=true;
        int sum,gray,difference;
        Byte *ptr1,*ptr2;
        for(int y=0;y<video_height;y++)
        {
                ptr1=(Byte *)background->ScanLine[y];
                ptr2=(Byte *)timeframe->ScanLine[y];
                for(int x=0;x<video_width*3;x+=3)
                {
                        sum=0;
                        for(int z=0;z<=2;z++)
                                sum+=ptr2[x+z];
                        gray=sum/3;
                        difference=abs(ptr1[x]-gray);
                        if(difference>TrackBar1->Position)
                        {
                                for(int z=0;z<=2;z++)
                                        ptr2[x+z]=255;
                        }
                        else
                        {
                                for(int z=0;z<=2;z++)
                                        ptr2[x+z]=0;
                        }
                }
        }
        Image1->Picture->Bitmap=timeframe;

        int sum2,gray2,difference2;

        capGrabFrameNoStop(hCapWnd2);
        capFileSaveDIB(hCapWnd2,"place2.bmp");
        timeframe2->LoadFromFile("place2.bmp");
        timeframe2->PixelFormat = pf24bit;
        Image2->AutoSize=false;
        Image2->Stretch=true;

        for(int y=0;y<video_height;y++)
        {
                ptr1=(Byte *)background2->ScanLine[y];
                ptr2=(Byte *)timeframe2->ScanLine[y];
                for(int x=0;x<video_width*3;x+=3)
                {
                        sum2=0;
                        for(int z=0;z<=2;z++)
                                sum2+=ptr2[x+z];
                        gray2=sum2/3;
                        difference2=abs(ptr1[x]-gray2);
                        if(difference2>TrackBar2->Position)
                        {
                                for(int z=0;z<=2;z++)
                                        ptr2[x+z]=255;
                        }
                        else
                        {
                                for(int z=0;z<=2;z++)
                                        ptr2[x+z]=0;
                        }
                }
        }
        Image2->Picture->Bitmap=timeframe2;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1change(TObject *Sender)
{
        int value;
        value=TrackBar1->Position;
        Label1->Caption=IntToStr(value);
}
//---------------------------------------------------------------------------
 int t2c;
void __fastcall TForm1::Button6Click(TObject *Sender)
{
  if (Edit1->Text != "")
  {
    Timer2->Enabled = true;
    StartTime = clock();
  }
  t2c=0;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button9Click(TObject *Sender)   //webcam2}ҼvJpanel2
{
        Timer3->Enabled=false;
        capDriverDisconnect(hCapWnd2);
        hCapWnd2=capCreateCaptureWindow("My Capture Window2", WS_VISIBLE | WS_CHILD ,0, 0,
        video_width, video_height,Panel2->Handle, 2);
        capDriverConnect (hCapWnd2, 0);
        capPreviewRate(hCapWnd2,30);
        capPreview(hCapWnd2,1);
        capDlgVideoSource (hCapWnd2);
        Panel2->DoubleBuffered = true;
        Timer3->Enabled=false;
        Button2->Enabled=true;


}
//---------------------------------------------------------------------------
int s;
void __fastcall TForm1::Timer2Timer(TObject *Sender)   //D2,QNwebcamvCj0.5N۰ʦs@i
{
float num;
  //--------------------------------------------------------timer2
  clock_t EndTime;

  Timer2->Interval = StrToFloat(Edit1->Text) * 1000;

  EndTime = clock();
  //Image1->Picture->SaveToFile("d://text.bmp");

  Label4->Caption = FloatToStr((float)(EndTime - StartTime)/StrToFloat(Edit1->Text));
  num=(float)(EndTime - StartTime)/StrToFloat(Edit1->Text);
    if(t2c=0)
        {
                for(num=0;num<10000;num++)
                Image1->Picture->SaveToFile(IntToStr(s)+".bmp");

                Image2->Picture->SaveToFile(IntToStr(s)+".bmp");
        }

}
//---------------------------------------------------------------------------



void __fastcall TForm1::Timer3Timer(TObject *Sender)
{
  /*     capGrabFrameNoStop(hCapWnd1);
        capFileSaveDIB(hCapWnd1,"place2.bmp");
        timeframe->LoadFromFile("place2.bmp");
        timeframe->PixelFormat = pf24bit;
        Image2->AutoSize=false;
        Image2->Stretch=true;
        int sum,gray,difference;
        Byte *ptr3,*ptr4;
        for(int y=0;y<video_height;y++)
        {
                ptr3=(Byte *)background->ScanLine[y];
                ptr4=(Byte *)timeframe->ScanLine[y];
                for(int x=0;x<video_width*3;x+=3)
                {
                        sum=0;
                        for(int z=0;z<=2;z++)
                                sum+=ptr4[x+z];
                        gray=sum/3;
                        difference=abs(ptr3[x]-gray);
                        if(difference>TrackBar2->Position)
                        {
                                for(int z=0;z<=2;z++)
                                        ptr4[x+z]=255;
                        }
                        else
                        {
                                for(int z=0;z<=2;z++)
                                        ptr4[x+z]=0;
                        }
                }
        }
        Image2->Picture->Bitmap=timeframe;   */

}
//---------------------------------------------------------------------------

